#include <unistd.h>
#include <stdio.h>

int p2open(char* comando, FILE* f[2]) {

    int	p1[2], p2[2];

    if (pipe(p1) == -1) {
	perror("pipe");
	return -1;
    }

    if (pipe(p2) == -1) {
	perror("pipe");
	close(p1[0]);
	close(p1[1]);
	return -1; 
    }

    switch(fork()) {
    case -1:
	close(p1[0]);
	close(p1[1]);
	close(p2[0]);
	close(p2[1]);
	return -1;
    case  0:
	dup2(p1[0], 0);
	dup2(p2[1], 1);
	close(p1[1]);
	close(p2[0]);
	execl("/bin/sh", "sh", "-c", comando, NULL);
	perror("execl");
	return -1;
    default:
	close(p1[0]);
	close(p2[1]);
	f[1] = fdopen(p2[0], "r");
	f[0] = fdopen(p1[1], "w");
	setlinebuf(f[0]);
	setlinebuf(f[1]);
	fflush(f[0]);
	fflush(f[1]);
    }
    return 0;
}
